<style type="text/css">
  .vispa-examples h4 {
    margin: 6px 0px 0px 0px;
  }

  .vispa-examples {
    margin: 20px 18px 20px 18px;
  }

  .vispa-examples .example {
    margin: 30px 18px 40px 18px;
  }

  .vispa-examples .example img {
    min-width: 100px;
    min-height: 150px;
    max-height: 200px;
    height: auto;
    width: auto;
    float: left;
    margin: 0px 10px 0px 0px;
  }

  .vispa-examples .btn-copy {
    float: right;
    margin: 8px 0px 0px 6px;
  }

  .vispa-examples .btn-reset {
    visibility: hidden;
    float: right;
    margin: 8px 0px 0px 6px;
  }

  .vispa-examples .col-md-6 {
    min-height: 150px;
  }
</style>
<div class="vispa-examples">

  <h2>Deep Learning</h2>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/1d-function-fitting/THUMBNAIL.png"
          alt="1D-fitting.png" title="1D fitting example">
        <h4>1D Function Fitting</h4>
        In this example, you can train a neural network to fit an arbitrary function and investigate the approximation
        performance during the training iterations.
        <div class="button-section" data-file="1d-function-fitting/train_1D_fit.py"
          data-copy="/home/public/vispa_examples/1d-function-fitting" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/mnist/THUMBNAIL.png"
          alt="mnist.png" title="MNIST example">
        <h4>MNIST Digit Recognition</h4>
        MNIST is a dataset of 28x28 greyscale images of handwritten digits and a classic task for benchmarking image
        classification algorithms. In this example, you can train and apply a simple convolutional neural network to
        identify the correct
        digit.
        <div class="button-section" data-file="mnist/mnist_cnn.py" data-copy="/home/public/vispa_examples/mnist"
          data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/cifar/THUMBNAIL.png"
          alt="image_classification_example.png" title="Image classification example">
        <h4>CIFAR-10 Image Classification</h4>
        CIFAR-10 is a dataset of tiny natural images showing objects of 10 different classes.
        It is a popular data set for experimenting with different deep learning techniques.
        In the provided examples you can train and apply: a fully connected net, a simple convolutional net and a deep
        convolutional net.
        <div class="button-section" data-file="cifar" data-copy="/home/public/vispa_examples/cifar"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/airshower_muons/THUMBNAIL.png"
          alt="airshower_muons.png" title="Airshower reconstruction using Deep Learning">
        <h4>Air Shower Classification</h4>
        Ultra-high energy cosmic rays produce extensive air showers, which vary among others with the cosmic ray mass.
        For tracking the cosmic rays back to their sources, the reconstruction of the charge is a key parameter hence it
        could allow for
        estimating the galactiv magnetic field deflection for each cosmic ray.
        In this example you can train a neural network on a toy data set to reconstruct the mass of the air shower
        (classification) and the showermaximum (regression).
        <div class="button-section" data-file="airshower_muons/train_mass.py"
          data-copy="/home/public/vispa_examples/airshower_muons" data-extension="CodeEditor">
          <div class="btn  btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/airshower_reconstruction/THUMBNAIL.png"
          alt="airshower.png" title="Airshower reconstruction using Deep Learning">
        <h4>Deep Learning based Air Shower Reconstruction</h4>
        Ultra-high energy cosmic rays produce extensive air showers of secondary particles upon entering the atmosphere.
        Sampling the footprint of these particles with surface detectors is a widely used detection technique.
        In this example you can exploit advanced convolutional techniques to reconstruct the energy and showeraxis of
        cosmic ray induced air showers.
        <div class="button-section" data-file="airshower_reconstruction"
          data-copy="/home/public/vispa_examples/airshower_reconstruction" data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/toptagging/THUMBNAIL.png"
          alt="airshower.png" title="Toptagging using Deep Neural Networks">
        <h4>Toptagging using Deep Neural Networks</h4>
        Top quarks are of special interest in high-energy physics due to their strong coupling to the Higgs boson.
        Additionally, they participate in many signal processes in LHC physics with strongly boosted event topologies.
        This examples allows you
        to discriminate top jets from qcd jets with a CNN and a DNN architecture. You can choose betweem two dataset:
        images of the jet constituents, and their four momenta.
        <div class="button-section" data-file="toptagging" data-copy="/home/public/vispa_examples/toptagging"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <!--<div class="col-md-6">-->
    <!--<div class="example">-->
    <!--<img src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/lorentz_boost_network/THUMBNAIL.png" alt="airshower.png" title="Example of the Lorentz-Boost Network">-->
    <!--<h4>Example of the Lorentz-Boost Network</h4>-->
    <!--A two-stage neural network architecture that enables a fully autonomous and comprehensive characterization of collision events by exclusively exploiting the four momenta of final-state particles.-->
    <!--The first stage of the architecture is the Lorentz-Boost Network.-->
    <!--<div class="button-section" data-file="lorentz_boost_network" data-copy="/home/public/vispa_examples/lorentz_boost_network" data-extension="FileBrowser">-->
    <!--<div class="btn btn-primary btn-copy btn-open">Open example</div>-->
    <!--<div class="btn btn-primary btn-reset">Reset example</div>-->
    <!--</div>-->
    <!--</div>-->
    <!--</div>-->
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/muon_dnn/THUMBNAIL.png"
          alt="airshower_muons.png" title="Implementation of a neural network">
        <h4>Muon DNN</h4>
        Implementation of a simple neural network from scratch.
        <div class="button-section" data-file="muon_dnn" data-copy="/home/public/vispa_examples/muon_dnn"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/sinewave/THUMBNAIL.png"
          alt="forecasting.png" title=„RNN">
        <h4>Introduction to (autoregressive) recurrent neural networks</h4>
        In this example, we will introduce recurrent neural networks (RNNs) and implement them using keras.
        The aim is to train a network to predict the periodicity of a sine wave using the autoregressive characteristic
        of RNNs.
        <div class="button-section" data-file="sinewave" data-copy="/home/public/vispa_examples/sinewave"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/radio_signals_rnn/THUMBNAIL.png"
          alt="cr_event.png" title=„RNN_classification">
        <h4>Cosmic-ray detection using recurrent networks</h4>
        In this example, we will exploit RNNs in the context of sequence classification.
        Therefore, we use a simulation of cosmic-ray-induced air shower signals measured by radion antennas.
        The task is to design an RNN that can identify if the measured signal traces (shortened to 500 time steps)
        contains a signal or not.
        <div class="button-section" data-file="radio_signals_rnn"
          data-copy="/home/public/vispa_examples/radio_signals_rnn" data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/cINN_example/THUMBNAIL.png"
          alt="airshower.png" title=„cINN">
        <h4>Conditional Invertible Neural Network for Parameter Estimation</h4>
        Parameter estimation including uncertainties is a fundamental part of experimental physics. In this example, a
        conditional Invertible Neural Network (cINN) is used to reconstruct 2 parameters of a Gaussian distribution.
        The cINN is able to create posterior distributions of the parameters using the inverse pass through the network.
        The mean of these posterior distributions can give an estimate of the actual parameter, whereas the width allows
        you to estimate the uncertainty on the parameters.
        Also, correlations of the parameters could be unveiled.
        <div class="button-section" data-file="cINN_example" data-copy="/home/public/vispa_examples/cINN_example"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/transformer/THUMBNAIL.png"
          alt="transformer.png" title=„transformer_networks">
        <h4>Transformer network for signal trace analysis</h4>
        Originally intended for natural language processing, transformers employ attention mechanisms to analyze
        sequential input. While achieving state-of-the-art results in language processing, they are also used in other
        fields (e.g. image recognition) with great success. In this example, a transformer based on the Multi-Head
        Attention method is used to count peaks in signal time traces.
        <div class="button-section" data-file="transformer/transformer.py"
          data-copy="/home/public/vispa_examples/transformer" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/vision_transformer/THUMBNAIL.png"
          alt="vision_transformer.png" title="vision_transformer">
        <h4>Transformer network for image recognition</h4>
        Vision transformers apply the transformer architecture to images by splitting them into patches and treating the
        set of patches like a series of words. This example uses a simple vision transformer to classify CIFAR-10
        images.
        <div class="button-section" data-file="vision_transformer/vision_transformer.py"
          data-copy="/home/public/vispa_examples/vision_transformer" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>

  <h3>Graph Neural Networks</h3>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/graph_networks/THUMBNAIL.png"
          alt="node_classification.png" title="GCN_sexample">
        <h4>Semi-Supervised Node Classification using Graph Convolutional Networks</h4>
        In this example we investigate semi-supervised node classification using Graph Convolutional Networks on
        Zachary's Karate Club dataset. Some time ago there was a dispute between the manager and the coach of the karate
        club which led to a
        split of the club into 4 groups.
        Can we use Graph Convolutional Networks to predict the affiliation of each member given the social network of
        the community and the memberships of only 4 people?
        <div class="button-section" data-file="graph_networks/karate_club.py"
          data-copy="/home/public/vispa_examples/graph_networks" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/graph_networks/THUMBNAIL2.png"
          alt="spherical_graph" title="DGCNN">
        <h4>MNIST using Fast Localized Spectral Convolutions</h4>
        In this example, the MNIST dataset is represented using a regular fixed graph. The classification of handwritten
        digits can be exploited with "Chebyshev Convolutions", allowing fast localized spectral filtering un graphs.
        <div class="button-section" data-file="graph_networks/mnist_cheb_spectral.py"
          data-copy="/home/public/vispa_examples/graph_networks" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/graph_networks/THUMBNAIL3.png"
          alt="spherical_graph" title="DGCNN">
        <h4>Signal Classification using Dynamic Graph Convolutions</h4>
        After a long journey through the universe before reaching the earth the cosmic rays interact again and again
        with the galactic magnetic field.
        To find a few outstanding sources of these particles, the interaction of the particle with the galactic magnetic
        field has to be taken into account.
        In this example, we investigate whether the measured 500 particles come from a significant source or from the
        mostly isotropic background using Dynamic Graph Convolutional Networks.
        <div class="button-section" data-file="graph_networks/spherical_arrival_directions.py"
          data-copy="/home/public/vispa_examples/graph_networks" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>

  <h3>Deep Generative Models</h3>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/gan_mnist/THUMBNAIL.png"
          alt="gan.png" title="GAN example">
        <h4>Generative Adversarial Networks (GANs) for MNIST</h4>
        In this example, you can generate handwritten digits by training a Deep Convolutional Generative Adversarial
        Network (DCGAN) to the MNIST data set.
        <div class="button-section" data-file="gan_mnist" data-copy="/home/public/vispa_examples/gan_mnist"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/airshower_wgan/THUMBNAIL.png"
          alt="airshower_wgan.png" title="Airshower WGAN example">
        <h4>Wasserstein GANs for Physics Simulations</h4>
        In this example, you can train a improved Wasserstein Generative Adversarial Network (WGAN) to generate signal
        patterns of cosmic ray induced air showers.
        <div class="button-section" data-file="airshower_wgan" data-copy="/home/public/vispa_examples/airshower_wgan"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>

  <br><br><br>
  <h2>Astroparticle Examples</h2>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/energy_distribution/THUMBNAIL.png"
          alt="auger_skymap_example.png" title="auger skymap example">
        <h4>Pierre Auger Observatory Data Analysis Example</h4>
        In this example, you can use the public data set (1 % of all events) of the Pierre Auger Observatory to study
        the energy distribution and to plot the arrival directions of cosmic rays.
        <div class="button-section" data-file="energy_distribution/auger.py"
          data-copy="/home/public/vispa_examples/energy_distribution" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/crpropa/THUMBNAIL.png"
          alt="crpropa_logo.png" title="CRPropa Logo">
        <h4>CRPropa Example 1D</h4>
        In this example, you can use CRPropa to simulate the expected energy spectrum of ultra-high-energy cosmic rays
        at Earth for specific assumptions about the sources.
        <div class="button-section" data-file="crpropa/sim1d.py" data-copy="/home/public/vispa_examples/crpropa"
          data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/crpropa_galactic_trajectories/THUMBNAIL.png"
          alt="crpropa_logo.png" title="CRPropa Logo">
        <h4>CRPropa Example Galactic Trajectories</h4>
        With this example, you can use CRPropa to simulate the trajectories of ultra-high-energy cosmic rays through a
        model of the Galactic magnetic field, by backtracking the particles from Earth to the edge of the Galaxy.
        <div class="button-section" data-file="crpropa_galactic_trajectories/sim.py"
          data-copy="/home/public/vispa_examples/crpropa_galactic_trajectories" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>
  <!-- <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img src="https://vispa.physik.rwth-aachen.de/data/_uploaded/image/1.0/Examples/fd_event_display.png" alt="auger_eventdisplay.png" title="Auger Event Display">
        <h4>Pierre Auger Observatory Event Display</h4>
        Have a look at ultra high energy cosmic rays measured at the Pierre Auger Observatory in Argentina.<br />
        (Password protected, only for members of the Pierre Auger Collaboration)
        <div class="button-section" data-file='{"filenames":["/home/public/auger/examples/data/public_data_hq_ADST.root"]}' data-tab-name="AugerPublicData" data-extension="augerofflineeventbrowser"
          data-tab='{"content":[[0,8,2,8,"sd-event-info-tile"],[4,0,4,12,"fd-camera-tile"],[2,8,2,8,"fd-event-info-tile"],[8,0,4,12,"sd-map-tile"],[0,0,4,8,"sd-ldf-tile"],[8,12,4,4,"sd-station-list-tile"]]}'>
          <div class="btn  btn-primary btn-copy btn-open">Open example</div>
        </div>
      </div>
    </div>
  </div> -->

  <!--<br><br><br>-->
  <!--<h2>CERN Examples</h2>-->
  <!--<div class="row">-->
  <!--<div class="col-md-6">-->
  <!--<div class="example">-->
  <!--<img src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/hello_lepton/THUMBNAIL.png" alt="leptop_pt_example.png" title="leptopn pT example">-->
  <!--<h4>Lepton p<sub>T</sub></h4>-->
  <!--One of the simplest and most frequently done steps during a physics analysis is to plot the distribution of kinematic variables. With this script, you can plot the distribution of the transverse momentum p<sub>T</sub> of electrons and-->
  <!--muons.<br>-->
  <!--<div class="button-section" data-file="hello_lepton/hello_lepton.py" data-copy="/home/public/vispa_examples/hello_lepton" data-extension="CodeEditor">-->
  <!--<div class="btn btn-primary btn-copy btn-open">Open example</div>-->
  <!--<div class="btn btn-primary btn-reset">Reset example</div>-->
  <!--</div>-->
  <!--</div>-->
  <!--<!-- <div class="example">-->
  <!--<img src="https://vispa.physik.rwth-aachen.de/data/_uploaded/image/1.0/Examples/feynman_Z_ee.png" alt="z_mass_example.png" title="Z mass example">-->
  <!--<h4>Z mass</h4>-->
  <!--Discover your first boson: While running this example, you can reconstruct the Z boson, the uncharged exchange particle (gauge boson) of the electroweak force. As a result, a plot with a peak at about 90 GeV, the mass of the Z boson, will be-->
  <!--shown.<br>-->
  <!--<span class="label label-warning">currently broken, due to ongoing software updates</span>-->
  <!--<div class="button-section" data-file="z_mass_designer/analysis.xml" data-copy="/home/public/CERN/examples/z_mass_designer" data-extension="PXLDesigner">-->
  <!--<div class="btn btn-primary btn-copy btn-open">Open example</div>-->
  <!--<div class="btn btn-primary btn-reset">Reset example</div>-->
  <!--</div>-->
  <!--</div> -->
  <!--</div>-->
  <!--</div>-->

  <br><br><br>
  <h2>Economics Examples</h2>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/stable_matching/THUMBNAIL.png"
          alt="stable matching" title="algorithm example">
        <h4>Improved algorithm for stable matching problem</h4>
        A common problem in economics is the problem of finding a stable matching between two equally sized sets of
        elements given an ordering of preferences for each element. This example implements an approximation algorithm
        for the case of
        one-sided ties (<a href="http://dx.doi.org/10.1007/978-3-319-07557-0_25"
          target="_blank">doi:10.1007/978-3-319-07557-0_25</a>).
        <div class="button-section" data-file="stable_matching/stable_matching.py"
          data-copy="/home/public/vispa_examples/stable_matching" data-extension="CodeEditor">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>

  <br><br><br>
  <h2>Information Field Theory Examples</h2>
  <div class="row">
    <div class="col-md-6">
      <div class="example">
        <img
          src="https://vispa.physik.rwth-aachen.de/server/fs/getfile?_workspaceId=1&path=/home/public/vispa_examples/nifty_tutorial/THUMBNAIL.png"
          alt="NIFTY_example.png" title="Numerical Information Field Theory - Getting Started 1">
        <h4>Numerical Information Field Theory</h4>
        NIFTy, "Numerical Information Field Theory", is a versatile library designed to enable the development of signal
        inference algorithms that operate regardless of the underlying grids (spatial, spectral, temporal, …) and their
        resolutions.
        Its object-oriented framework is written in Python, although it accesses libraries written in C++ and C for
        efficiency.
        <div class="button-section" data-file="nifty_tutorial" data-copy="/home/public/vispa_examples/nifty_tutorial"
          data-extension="FileBrowser">
          <div class="btn btn-primary btn-copy btn-open">Open example</div>
          <div class="btn btn-primary btn-reset">Reset example</div>
        </div>
      </div>
    </div>
  </div>
</div>